#include "type.h"
#include "term.h"
#include "alphabet.h"

void Alphabet :: add(Constant* c) {
  insert(pair<string,Constant*>(c->to_string(), c));
}

bool Alphabet :: contains(string key) {
  return find(key) != end();
}

void Alphabet :: free_memory() {
  map<string,Constant*>::iterator it;

  for (it = begin(); it != end(); it++) {
    delete it->second;
  }
  clear();
}

string Alphabet :: to_string() {
  map<string,Constant*>::iterator it;
  string ret;
  
  ret = "{";
  for (it = begin(); it != end(); it++) {
    ret = ret + it->second->to_string_complete() + ", ";
  }
  return ret.substr(0,ret.length()-2) + "}";
}

