#include "beta.h"
#include "substitution.h"

PTerm Beta :: apply_top(PTerm term) {
  if (!applicable_top(term)) return term;

  PTerm left = term->subterm("1");
  PVariable var = left->query_abstraction_variable();
  PTerm right = term->subterm("2");

  Substitution sub;
  sub[var] = right;
  PTerm result = left->subterm("1")->apply_substitution(sub);
  delete var;
  delete left;
  right->free_memory();
  return result;
}

bool Beta :: applicable_top(PTerm term) {
  return term->query_application() &&
         term->subterm("1") != NULL &&
         term->subterm("1")->query_abstraction();
}

