#ifndef BETA_H
#define BETA_H

#include "term.h"
#include "rule.h"

/**
 * This class implements the beta rule, which is commonly used in
 * higher order rewrite systems (although depending on the actual
 * system used it might be a separate rule or an implicit step
 * following each rule step).
 */

class Beta : public Rule {
  protected:
    PTerm apply_top(PTerm term);
    bool applicable_top(PTerm term);

  public:
    Beta() : Rule("beta") {}
};

#endif
