#ifndef TERMREWRITEPROGRAM_H
#define TERMREWRITEPROGRAM_H

/**
 * Inherit this class to write your program in!
 */

#include "type.h"
#include "term.h"
#include "alphabet.h"
#include "environment.h"
#include "termrewritesystem.h"

class TermRewriteProgram {
  private:
    void remove_outer_spaces(string &description);
    void remove_outer_brackets(string &description);
    void normalise(string &description);
    bool check_empty(string description, string warning);
    bool check_illegal(string description, bool type);
    bool check_correct_bracket_matching(string description);
    bool contains(string description, char c);
    int find_substring(string description, string sub);
    bool complete_type(PType type);
    bool matching_type(PType incomplete, PType complete);

    PType TYPE_helper(string description);
    PTerm TERM_helper(string description, Alphabet sigma, Environment
      &gamma, PType expected_type, int &errcode);

  protected:
    TermRewriteSystem system;

    PType TYPE(string description);
    PTerm TERM(string description, Alphabet sigma, Environment &gamma,
      PType expected_type = NULL);
};

#endif
