#ifndef SUBSTITUTION_H
#define SUBSTITUTION_H

/**
 * This class encodes a substitution; it is simply a container class
 * mapping variables to terms.
 *
 * It is the responsibility of the class using Substitution (mostly
 * children of Term) to commit a substitution.
 * A substitution may not duplicate terms in the Substitution!  They
 * must always be copied, as otherwise more than one pointer to the
 * same term might exist, which breaks the moment you change one.
 */

#include <map>
#include "term.h"

class Substitution : public map<PVariable,PTerm> {
  public:
    bool contains(PVariable key);
    void free_memory();
    void print();
};

#endif

